<?php

namespace App\Http\Controllers\API;

use App\Traits\StatementTrait;
use http\Cookie;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Validator;

class StatementController extends Controller
{
    use StatementTrait;

    public function __construct()
    {
        $this->middleware('auth:api');
    }

    public function index(Request $request)
    {
        $validator = Validator::make($request->all(),[
            'from_date'=>'nullable|date',
            'to_date'=>'nullable|date'
        ]);
        if($validator->fails())
        {
            return response()->json([
                "status"=>0,
                "status_code"=>400,
                "message"=>"Invalid user request",
                "errors"=>$validator->errors()
            ]);
        }
        $user = $request->user();

        $user_statement =
            $this->getUserStatementSummary($user->Membership_id,$user->Company_id,$request->from_date,$request->to_date);
        $limit = $request->input("limit")<1?10:$request->input("limit");

        $user_statement = $user_statement->paginate($limit);
        return response()->json([
            "status"=>1,
            "status_code"=>200,
            "user_statements"=>$user_statement
        ]);
    }
}
