<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Traits\SurveyTrait;
use App\Models\Survey\SurveyResponse;

class SurveyController extends Controller
{
    use SurveyTrait;

    public function __construct()
    {
        $this->middleware('auth:api');
    }
    public function getSurveys(Request $request)
    {
        $user = $request->user();
    
        $response['status']= 1;
        $response['surveys']= $this->getUserSurveys($user->Company_id,$user->Enrollment_id);
        return response()->json($response);
    }

    public function showSurvey(Request $request,$surveyId)
    {
        $user = $request->user();
        $response['status']= 1;
        $response['surveys']= $this->getSurveyDetail($user->Company_id,$user->Enrollment_id,$surveyId);
        return response()->json($response);
    }

    public function submitSurvey(Request $request,$surveyId)
    {
        $user = $request->user();
       $exist_survey= $this->getUserSurveys($user->Company_id,$user->Enrollment_id)
                        ->where('Survey_id',$surveyId)->first();
        if($exist_survey==null)
        {
            $response['status'] = 0;
            $response['message'] = "You have completed this survey already";
            return response()->json($response);
        }
        $questions = $this->getSurveyDetail($user->Company_id,$user->Enrollment_id,$surveyId)->questions;
        $user_responses = $request->survey_responses;
        $validated_responses = $this->validateResponses($questions,$user_responses);
        if($validated_responses['status'] ==1)
        {
           
            foreach($validated_responses['valid_questions'] as $valid_response)
            {
                SurveyResponse::create([
                    'Enrollment_id'=>$user->Enrollment_id,
                    'Company_id'=>$user->Company_id,
                    'Survey_id'=>$valid_response['survey_id'],
                    'Question_id'=>$valid_response['question_id'],
                    'Response1'=>$valid_response['response_type']==2?$valid_response['response']:null,
                    'Response2'=>$valid_response['response_type'],
                    'Choice_id'=>$valid_response['response_type']!=2?$valid_response['choice_id']:0,
                    'Create_user_id'=>7,
                    'Update_user_id'=>7,
                    'Create_date'=>date('Y-m-d h:i:s',time()),
                    'Update_date'=>date('Y-m-d h:i:s',time()),
                ]);
            }
            $response['status'] = 1;
            $response['message'] = "Thanks, Survey has been submitted successfully";
            return response()->json($response);
        }else{
           $response['status'] = 0;
           $response['message'] = "Invalid survey is submit";
           $response['invalid_items'] = $validated_responses['invalid_questions'];
           return response()->json($response);
        }
    }
}
