<?php

namespace App\Http\Controllers\API;

use App\Traits\UserNotificationTrait;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Input;

class UserNotificationController extends Controller
{
    use UserNotificationTrait;

    public function __construct()
    {
        $this->middleware('auth:api');
    }

    public function index(Request $request)
    {
        $user = $request->user();
        $limit = Input::get('limit');
        $read = Input::get('read')!=null?Input::get('read'):null;

        $notifications = $this->getUserNotifications($user->Membership_id,$limit,$read);
        return response()->json($notifications);
    }

    public function markAsRead(Request $request,$notification_id)
    {
       $this->markAsOpen($notification_id);
        return response()->json(1);
    }

    public function deleteNotification(Request $request,$notification_id)
    {
        $this->deleteUserNotification($notification_id);
        return response()->json((object)[
            'status'=>1,
            "message"=>'You have deleted a notification'
        ]);
    }
}
