<?php

namespace App\Mail\Pin;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class PinResetMail extends Mailable
{
    use Queueable, SerializesModels;
    private $user;
    public $company;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($user,$company)
    {
        //
        $this->user = $user;
        $this->company = $company;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->subject('Pin Reset Successful')
            ->markdown('vendor.notifications.email')->with([
                "level" => "default",
                "greeting" => "Hi, ".$this->user->First_name."!",
                "introLines" => [
                    "You have reset your pin successfully."
                ],
                "company" => $this->company,
                "outroLines" => [
                    "If you did reset pin, no further action is required."
                ]
            ])->with([ "company" => $this->company]);
    }
}
