<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Collection;


class MerchandizeCategory extends Model
{
    protected $table="lsl_merchandize_category";
    protected $primaryKey="Merchandize_category_id";

    protected $hidden = [
        'Create_user_id','Create_date','Update_user_id','Update_date'
    ];

    public function companies()
    {
        return $this->belongsToMany('App\Models\Company','lsl_company_merchandize_category',
        'LSL_Merchandize_category_id','Company_id');
    }

    public function products()
    {
        return $this->hasMany('App\Models\MerchandizeCatalogue','Merchandize_category_id'
            )->with('branches');
    }

    public function formatSubmenu()
    {
       return new Collection([
                "Merchandize_category_id"=>$this->Merchandize_category_id,
                "Merchandize_category_name"=>$this->Merchandize_category_name,
                "products"=>$this->products->map(function ($product){
                    return $product->format();
                })
            ]);

    }
    public function formatTop()
    {
        return new Collection([
            "Parent_id"=>$this->Merchandize_category_id,
            "Parent_name"=>$this->Merchandize_category_name,
            'sub_categories'=>$this->sub_menus->map(function($sub_menu){
                return $sub_menu->formatSubmenu();
            })
        ]);
    }

    public function sub_categories()
    {
        return $this->hasMany('App\Models\MerchandizeCategory','Parent_id','Merchandize_category_id')
        ->where('Parent_id','<>',0)
        ->where('Link_flag','<>',1)
        ->select('Merchandize_category_id','Merchandize_category_name','Parent_id')
            ->with('sub_categories');
    }

      public function sub_menus(){
             return $this->hasMany('App\Models\MerchandizeCategory','Parent_id','Merchandize_category_id')
             ->where('Parent_id','<>',0)
             ->where('Link_flag',1)
             ->select('Merchandize_category_id','Merchandize_category_name','Parent_id')->with('products');
      }

}
