<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class TempCart extends Model
{
    protected $table="lsl_temp_cart";
    protected $primaryKey="Temp_cart_id";
    protected $fillable=[
        'Item_code','Enrollment_id','Remark','Branch',
        'Redemption_method','Company_id'
    ];
    public $timestamps = false;

    public function product()
    {
        return $this->hasOne('App\Models\MerchandizeCatalogue',"Merchandize_item_code",'Item_code');
    }

    public function branches(){
        return $this->belongsToMany('App\Models\BranchMaster',"lsl_merchandize_item_child",
        "Merchandize_item_code","Branch_code","Item_code","Branch_code")->select("State_id");
    }

    public function branch_codes(){
        return $this->belongsToMany('App\Models\BranchMaster',"lsl_merchandize_item_child",
        "Merchandize_item_code","Branch_code","Item_code","Branch_code")->select("lsl_merchandize_item_child.Branch_code");
    }

    
}
