<?php

namespace App\Traits;


use App\Models\BranchMaster;

trait BranchTrait
{
    protected  function allBranches($company_id)
    {
        return BranchMaster::where('Company_id',$company_id)->where("Active_flag",1)
            ->where("Partner_id","<>",0)
            ->orderBy("Branch_name",'asc')->get()->map(function($branch){
                return $branch->formatIndex();
            });
    }

    protected  function getBranchCatalogues($branch_code,$company_id,$program_id)
    {
        return BranchMaster::with(['products_categories.products'=>function($query)use($branch_code,$program_id){
            return $query->join('lsl_merchandize_item_child AS item',function($query)use($branch_code){
                return $query->on("item.Merchandize_item_code","="
                    ,"lsl_company_merchandise_catalogue.Merchandize_item_code")
                    ->where("item.Branch_code",$branch_code);
            })->where("Active_flag",1)->where("Loyalty_program_id",$program_id);
        }])->where('Company_id',$company_id)->where("lsl_branch_master.Active_flag",1)
            ->where("Branch_code",$branch_code)->first();
    }
}
