<?php

namespace App\Exceptions;

use Exception;
use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Symfony\Component\HttpKernel\Exception\AccessDeniedHttpException;

class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array
     */
    protected $dontReport = [
        //
    ];

    protected $dontFlash = [
        'password',
        'password_confirmation',
    ];

    public function report(Exception $exception)
    {
        parent::report($exception);
    }


    public function render($request, Exception $exception)
    {

        if($exception instanceof \Illuminate\Auth\AuthenticationException ){
            return response([
                "message"=>'User unauthenticated',
                "status_code"=>401
            ], 401);
        }
        if($exception->getCode()==500)
        {
            return response([
                "message"=>$exception->getMessage(),
                "file"=>$exception->getFile(),
                "error_trace"=>$exception->getTrace(),
                "status_code"=>500
            ], 500);
        }
        return parent::render($request, $exception);
    }
}
