<?php

namespace App\Mail\Pin;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class AccountLockedMail extends Mailable
{
    use Queueable, SerializesModels;
    private $callback_url;
    private $user;
    public $company;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($user,$callback_url,$company)
    {
        //
        $this->callback_url = $callback_url;
        $this->user = $user;
        $this->company = $company;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->subject('Account Locked Out Mail')
            ->markdown('vendor.notifications.email')->with([
                "level" => "default",
                "greeting" => "Hi, ".$this->user->First_name."!",
                "introLines" => [
                    "You are receiving this email because you requested for transaction pin 
                    reset for your account "
                ],
                "actionText" => "Reset Pin",
                "actionUrl" => $this->callback_url,
                "outroLines" => [
                    "If you did not request for transaction pin reset, no further action is required."
                ]
            ])->with([ "company" => $this->company]);
    }
}
