<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Collection;

class MerchandizeCatalogue extends Model
{
    protected $table="lsl_company_merchandise_catalogue";
    protected $primaryKey="Company_merchandise_item_id";

    public function branches()
    {
        return $this->belongsToMany('App\Models\BranchMaster',"lsl_merchandize_item_child",
        "Merchandize_item_code","Branch_code","Merchandize_item_code",
            "Branch_code");
    }
    public function category(){
        return $this->belongsTo('App\Models\MerchandizeCategory','Merchandise_category_id');
    }

    public function program()
    {
        return $this->belongsTo('App\Models\LoyaltyProgram','Loyalty_program_id');
    }
    public function company_partner()
    {
        return $this->hasOne('App\Models\CompanyPartner',"Partner_id",'Partner_id');
    }

    public  function format()
    {
        return new Collection([
            "Company_merchandise_item_id"=>$this->Company_merchandise_item_id,
            "Merchandize_item_code"=>$this->Merchandize_item_code,
            "Merchandize_item_name"=>$this->Merchandize_item_name,
            "Merchandise_item_description"=>$this->Merchandise_item_description,
            "Item_image"=>$this->Item_image,
            "Sale_flag"=>$this->Sale_flag,
            "Price"=>$this->Billing_price_in_points,
            "Old_price"=>$this->Old_price_in_points,
            "Delivery_method"=>$this->Delivery_method,
            "Branch_code"=>$this->branches->first()->Branch_code
        ]);
    }
}
