<?php

namespace App\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Notifications\Notification;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;

class PasswordResetRequest extends Notification
{
    use Queueable;
    private $callback_url;

    public function __construct($callback_url)
    {
        $this->callback_url = $callback_url;
    }


    public function via($notifiable)
    {
        return ['mail'];
    }

    public function toMail($notifiable)
    {

        return (new MailMessage)
                    ->line('You are receiving this email because we 
                    received a password reset request for your account.')
                    ->action('Reset Password', $this->callback_url)
                    ->line('If you did not request a password reset, 
                            no further action is required.')
            ->from('host@perx.com')
            ->subject("Password Reset Mail");
    }

    /**
     * Get the array representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return array
     */
    public function toArray($notifiable)
    {
        return [
            //
        ];
    }
}
