<?php

namespace App\Providers;

use Illuminate\Mail\Mailer;
use Illuminate\Support\ServiceProvider;

class AppServiceProvider extends ServiceProvider
{
    /**
     * Register any application services.
     *
     * @return void
     */
    public function register()
    {
        $this->app->bind('company.mailer', function ($app, $parameters) {
            $smtp_host = $parameters["SMTP_host"];
            $smtp_port = $parameters["SMTP_port"];
            $smtp_username = $parameters["SMTP_username"];
            $smtp_password = $parameters["SMTP_password"];
            $smtp_encryption = $parameters["SMTP_encryption"];

            $from_email = $parameters["From_email"];
            $from_name = $parameters["From_name"];

            $reply_email = $parameters["Reply_email"];
            $reply_name = $parameters["Reply_name"];

            $transport = new \Swift_SmtpTransport($smtp_host, $smtp_port);
            $transport->setUsername($smtp_username);
            $transport->setPassword($smtp_password);


            $transport->setEncryption($smtp_encryption);
            $swift_mailer = new \Swift_Mailer($transport);

            $mailer = new Mailer($app->get('view'), $swift_mailer, $app->get('events'));
            $mailer->alwaysFrom($from_email, $from_name);

            $mailer->alwaysReplyTo($from_email, $from_email);

            return $mailer;
        });
    }

    /**
     * Bootstrap any application services.
     *
     * @return void
     */
    public function boot()
    {
        //
    }
}
