<?php

namespace App\Traits;
use DB;
use App\Models\TempCart;



trait CartTrait 
{
    protected function getUserCartItems($enrollment_id)
    {
       return  TempCart::with("product")
            ->join('lsl_company_merchandise_catalogue', 'lsl_temp_cart.Item_code','=',
             'lsl_company_merchandise_catalogue.Company_Merchandize_item_code')
            ->select(DB::raw('count(*) as Quantity,sum(lsl_company_merchandise_catalogue.Billing_price_in_points) as Amount'),"Item_code","Redemption_method","Branch","Remark")
            ->where("Enrollment_id",$enrollment_id)->groupBy(["Redemption_method","Branch","Item_code","Remark"])
            ->get();
    }

    protected function getUserCart($enrollment_id)
    {
        return TempCart::where("Enrollment_id",$enrollment_id)->get();
    }

    protected function getSingleCartItem($cart_id){
        return TempCart::with("product")->where("Temp_cart_id",$cart_id)->first();
    }
}
