<?php

namespace App\Traits;
use App\Models\Survey\SendSurvey;
use App\Models\Survey\SurveyStructure;

trait SurveyTrait 
{
    protected function getUserSurveys($company_id,$enrollment_id)
    {
       return SurveyStructure::whereHas('send_surveys',function($survey)use($company_id,$enrollment_id){
            $survey->where('Company_id',$company_id)->where('Enrollment_id',$enrollment_id);
        })
        ->whereDoesntHave('survey_responses',function($survey_response)use($enrollment_id,$company_id){
            $survey_response->where('Enrollment_id',$enrollment_id)->where('Company_id',$company_id);
        })
        ->select('Survey_id','Survey_name','No_of_questions',
        'Reminder_days_before','Reminder_days_after','Survey_points')
        ->where('Active_flag',1)->where('Status',1)->get();
    }

    protected function getSurveyDetail($company_id,$enrollment_id,$survey_id)
    {
       return SurveyStructure::with('questions')->whereHas('send_surveys',function($surveys)
       use($company_id,$enrollment_id){
            $surveys->where('Company_id',$company_id)->where('Enrollment_id',$enrollment_id);
        })->select('Survey_id','Survey_name','No_of_questions',
        'Reminder_days_before','Reminder_days_after','Survey_points')
        ->where('Active_flag',1)->where('Status',1)
        ->where('Survey_id',$survey_id)->first();
    }

    protected function validateResponses($questions,$user_responses)
    {
        $invalid_responses = [];
        $valid_response =[]; 
       
        foreach($user_responses as $response)
        {
            
            $question = $questions
            ->where('Question_id',$response['question_id'])->first();
            if($question == null)
            {
                $tmp['question'] = $response;
                $tmp['reason'] = "Question does not exist";
               $invalid_responses[] =$tmp; 
            }else{
                if($response['response_type']!=$question->Response_type)
                {
                    $tmp['question'] = $response;
                    $tmp['reason'] = "Invalid response type";
                   $invalid_responses[] =$tmp;
                }
            }
        }

        if(count($invalid_responses) > 0)
        {
            $final_resonse['status'] = 0;
            $final_resonse['invalid_questions'] = $invalid_responses;
            return $final_resonse;
        }else{
            $final_resonse['status'] = 1;
            $final_resonse['valid_questions'] = $user_responses;
            return $final_resonse;
        }
    }
}
