<?php

namespace App\Http\Controllers\API;

use App\Models\MerchandizeCatalogue;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Company;
use App\Models\MerchandizeCategory;
use App\Http\Resources\Category\CategoryResource as CategoryResource;

class CategoryController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth:api');
    }

    public function nested_categories(Request $request)
    {
        $company_id = $request->user()->Company_id;

        $categories = MerchandizeCategory::with('sub_categories')->whereHas('companies',function($query)use($company_id){
                return $query->where('lsl_company_merchandize_category.Company_id',$company_id);
        })->where('parent_id',0)
        ->select('Merchandize_category_id','Merchandize_category_name','Link_flag')->get();
        return response()->json($categories);
    }

    public function nested_categories_products(Request $request,$branch_code,$id)
    {
        $parent_category = MerchandizeCategory::with('sub_menus')->whereHas('sub_menus',function($query)use($branch_code){
           return $query->whereHas('products',function($p_query)use($branch_code){
               return $p_query->where('Active_flag',1)->whereHas('branches',function($b_query)use($branch_code){
                   return $b_query->where('Active_flag',1)
                       ->where('lsl_branch_master.Branch_code',$branch_code);
               });
           });
        })->where('Merchandize_category_id',$id)
        ->select('Merchandize_category_id','Merchandize_category_name','Link_flag')->first();
        $parent_category = $parent_category?$parent_category->formatTop():null;
        return response()->json($parent_category);
    }

    public function company_categories(Request $request)
    {
        $user = $request->user();
       $company_id = $user->Company_id;
       $categories = new CategoryResource(MerchandizeCategory::whereHas('companies',function($query)use($company_id){
        $query->where('lsl_company_merchandize_category.Company_id',$company_id);
        })->where('Link_flag',1)->get());
        return response()->json($categories);
    }
}
