<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\TempCart;
use DB;
use App\Traits\CartTrait;
use App\Http\Resources\Checkout\CheckoutResource as CheckoutResource;

class CheckoutController extends Controller
{
    use CartTrait;
    public function __construct()
    {
        $this->middleware('auth:api');
    }

    public function getCheckOutItems(Request $request)
    {
        $user = $request->user();

        $cart_items = CheckoutResource::collection($this->getUserCartItems($user->Enrollment_id));

        $pin_validation = DB::table('lsl_company_master')->where('Company_id',$user->Company_id)->first()->Cust_redeem_pin_validation;
        $delivery_items =  $cart_items->where('Redemption_method',2)->count();
        if($delivery_items > 0)
        {
            if(count($cart_items->where('Redemption_method',2)) >0)
            {
                $response['states'] = \DB::table('lsl_state_master')->select('State_id','State_name')->get();
            }
           $shipping_addresses = DB::table('lsl_shipping_master')
           ->where('Enrollment_id',$user->Enrollment_id)->get();

           $response["Shipping_addresses"]  = $shipping_addresses;
        }
        $response['Pin_validation_enabled']= $pin_validation;
        $response["Cart_total"] = $cart_items->sum("Amount");
        $response['Delivery_items'] = $delivery_items;
        $response['Count'] = count($cart_items);
        $response['Items'] =$cart_items;
        return response()->json($response);
    }
}
