<?php

namespace App\Http\Controllers\API;

use App\Jobs\CustomRawMailJob;
use App\Models\Company;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;

class ContactController extends Controller
{
    public function index(Request $request,$slug)
    {
        $validator = Validator::make($request->all(),[
            'first_name'=>'required',
            'last_name'=>'required',
            'email'=>'required|email',
            'phone_number'=>'required',
            'message'=>'required',
        ]);
        if($validator->fails())
        {
            $response['status']=0;
            $response['errors']=$validator->errors();
            return response()->json($response);
        }

        $company = Company::whereHas('programs',function($query)use($slug){
            return $query->where('slug',$slug);
        })->with('mail_configuration')->first();
        if($company==null)
        {
            $response['status']=0;
            $response['message']="Invalid company slug";
            return response()->json($response);
        }
        $subject="From ".$request->last_name." ".$request->first_name." (".$request->phone_number.")";
        CustomRawMailJob::dispatch($company->mail_configuration->toArray(),
            $company->Contact_us_first_email,$company->Contact_us_first_name
            ,$request->message,$request->email,$subject);
        $response['status']=1;
        $response['message']="You message has been sent successfully";
        return response()->json($response);
    }
}
