<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\EnrollmentMaster;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;


class UserController extends Controller
{

    public function __construct(){
        $this->middleware("auth:api");
    }
    public function user_profile(Request $request)
    {
        $profile = EnrollmentMaster::with(['tier'])
        ->find($request->user()->Enrollment_id)->format();
       $states = DB::table('lsl_state_master')->where("Country_id",1)->get();
       $cities = DB::table("lsl_city_master")->where('State_id',$profile->State_id)->get();
        return response()->json(['profile'=>$profile,"states"=>$states,'cities'=>$cities]);
    }

    public function update_profile(Request $request)
    {
        $validator = Validator::make($request->all(),[
            'first_name'=>'required',
            'last_name'=>'required',
            'country_id'=>'required',
            'city_id'=>'required',
            'state_id'=>'required',
            'country_id'=>'required',
            'phone_no'=>'required',
            'current_address'=>'required'
        ]);

        if($validator->fails())
        {
            return response()->json([
                'status'=>0,
                'errors'=>$validator->errors()
            ]);
        }


        $city = DB::table('lsl_city_master')
            ->where('City_id',$request->city_id)->where('State_id',$request->state_id)
            ->where('Country_id',$request->country_id)->first();
        if($city==null)
        {
            return response()->json([
                'status'=>0,
                'message'=>"Invalid city of ID"
            ]);
        }
        $user = $request->user();
        $user->fill([
            'City_id'=>$city->City_id,
            'Country_id'=>$city->Country_id,
            'State_id'=>$city->State_id,
            'First_name'=>$request->first_name,
            'Last_name'=>$request->last_name,
            'Phone_no'=>$request->phone_no,
            'Current_address'=>$request->current_address
        ]);
        $user->save();
        return response()->json([
            'status'=>1,
            'message'=>"Profile updated successfully",
        ]);
    }
}
