<?php

namespace App\Jobs;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;

class CustomMailJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;
    /**
     * @var array
     */
    public $configuration;
    /**
     * @var Mailable
     */
    public $mailable;
    /**
     * @var string
     */
    public $to;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct(array $configuration, string $to, Mailable $mailable)
    {
        $this->configuration = $configuration;
        $this->to = $to;
        $this->mailable = $mailable;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $mailer = app()->makeWith('company.mailer', $this->configuration);

        $mailer->to($this->to)->send($this->mailable);

    }
}
