<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class BranchMaster extends Model
{
    protected $table="lsl_branch_master";
    protected $primaryKey="Branch_id";

    public function products()
    {
        return $this->belongsToMany("App\Models\MerchandizeCatalogue","lsl_merchandize_item_child",
        "Branch_code","Merchandise_item_code",
            'Branch_code','Merchandize_item_code');
    }

    public function categories()
    {
        return $this->belongsToMany('App\Models\MerchandizeCategory','lsl_company_merchandize_category',
            'Company_id','LSL_Merchandize_category_id','Company_id')
            ->with('products');
    }

    public function formatIndex()
    {
        return [
            "Branch_id"=>$this->Branch_id,
            "Branch_name"=>$this->Branch_name,
            "Branch_code"=>$this->Branch_code,
            "Address"=>$this->Address
        ];
    }
    public function format()
    {
        return [
                "Branch_id"=>$this->Branch_id,
                "Branch_name"=>$this->Branch_name,
                "Company_id"=>$this->Company_id,
                "Branch_code"=>$this->Branch_code,
                "Address"=>$this->Address,
                "Categories"=>$this->categories->map(function($category){
                return $category->format();
            })
        ];
    }

}
