<?php

namespace App\Traits;
use Illuminate\Support\Facades\DB;

trait KnockoutTrait
{
    protected function deductUserPoints($user_points,$item_amount,$enrollment_id,
                                          $redemption_transaction_id,$company_id,$bill_no,$voucher_no)
{
    $user_points = $user_points;
    $balance = $item_amount;
    $current_point_index = 0;
    foreach($user_points as $point)
    {
        $trans_point =  $point->sumtotal - $point->Knockout_points;
        if($trans_point > 0)
        {
            if($trans_point < $balance)
            {
                $balance -= $trans_point;
                $knocked_points  = $trans_point;
            }else{
                $knocked_points = $balance;
                $balance = 0 ;
            }

            \DB::table('lsl_transaction_knockout_child')->insert([
                'Redeemption_transaction_id'=>$redemption_transaction_id,
                'Purchase_transaction_id'=>$point->Transaction_id,
                'Company_id'=>$company_id,
                'Knockout_points'=>$knocked_points,
                'Bill_no'=>$bill_no,
                'Voucher_no'=>$voucher_no,
            ]);
            \DB::table('lsl_transaction')->where('Transaction_id',$point->Transaction_id)
                ->update(['Knockout_points'=>$knocked_points]);

            $point->Knockout_points += $knocked_points;
            $user_points[$current_point_index] = $point;

            if($balance <= 0)
                break;
        }
        if($point->Knockout_points >= $point->sumtotal)
        {
            $current_point_index++;
        }
    }


}
    protected function getUserPoints($company_id,$enrollment_id)
    {
        return \DB::table('lsl_transaction')
            ->select(DB::raw("(Loyalty_points + Bonus_points + Transfer_points) AS sumtotal"),"Transaction_id","Member1_enroll_id","Loyalty_points","Knockout_points","Bonus_points","Transfer_points",
                "Transaction_status")->where("Company_id",$company_id)->where('Transaction_status',0)->where('Member1_enroll_id',$enrollment_id)
            ->whereIn('Transaction_type_id',[1,3,13,22,21,27,28,29,30])
            ->groupBy(["Transaction_id","Member1_enroll_id","Loyalty_points","Loyalty_points","Knockout_points","Bonus_points","Transfer_points","Transaction_status"])
            ->havingRaw('sumtotal > Knockout_points')
            ->orderBy('Transaction_id','asc')->get()->toArray();
    }

}
