<?php

namespace App\Traits;


use Illuminate\Support\Facades\DB;

trait UserNotificationTrait
{
    protected function createNotification($user,$content,$notification_type,$order_no)
    {
        DB::table('lsl_user_notification_master')->insertGetId([
            'User_email_id'=>$user->User_email_id,
            'Company_id'=>$user->Company_id,
            'Membership_id'=>$user->Membership_id,
            'Notification_type'=>$notification_type,
            'Contents'=>$content,
            'Reference_no'=>$order_no,
            'Create_user_id'=>11,
            'Note_open'=>0,
            'Creation_date'=>date("Y-m-d",time()),
            'Disable_flag'=>0,
        ],'User_notification_id');
    }


    public function getUserNotifications($membership_id,$limit,$read)
    {

        $limit = $limit==null?20:$limit;

        return DB::table('lsl_user_notification_master AS noti')
            ->leftJoin('lsl_transaction_type_master as transc','noti.Notification_type','=',
                'transc.transaction_type_id')
            ->where('Membership_id',$membership_id)
            ->where('Disable_flag',0)
            ->when($read!=null,function($query)use($read){
                    return $query->where('Note_open',$read);
            })
            ->select('User_notification_id','Contents','User_email_id','Company_id',
                'Membership_id','Reference_no','Creation_date','Note_open','transc.Transaction_type_name AS Transaction_type')
                ->orderBy('User_notification_id',"desc")->paginate($limit);
    }

    public  function markAsOpen($notification_id)
    {
        DB::table('lsl_user_notification_master')
            ->where('User_notification_id',$notification_id)->update(['Note_open'=>1]);
    }

    public  function deleteUserNotification($notification_id)
    {
        DB::table('lsl_user_notification_master')
            ->where('User_notification_id',$notification_id)->delete();
    }
}
