<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use App\Models\EnrollmentMaster;
use App\Models\LoyaltyProgram;
use Validator;
use Carbon\Carbon;

class AuthController extends Controller
{
    public function createToken(Request $request,$company)
    {
        $company = LoyaltyProgram::where('slug',$company)->first();
        if(!$company){
            return response()->json(['message'=>'Invalid company identifier',"status"=>0],200);
        }
        if(!$company->Active_flag){
            return response()->json(['message'=>'Company is not active',"status"=>0],200);
        }
        $validator = Validator::make($request->all(), [
            'email' => 'required|email',
            'password' => 'required'
        ]);
        if ($validator->fails()) {
            return response()->json(['message'=>"Invalid email or password","status"=>0], 200);
        }
        $success = [];
        $user = EnrollmentMaster::where('User_email_id',$request->email)
                ->where('Password',$request->password)
                ->where("Company_id",$company->Company_id)
                ->select(['First_name','Active_flag','Current_balance',
                'LoggedIn_flag','Membership_id','User_email_id','Last_login_datetime','Enrollment_id','Company_id'])
                ->first();
        if($user)
        {
            if($user->Active_flag){
                $user->Loggedin_flag = 1;
                $user->Last_login_datetime = date("Y-m-d H:i:s",time());
                $user->save();
                $user->tokens()->delete();
                $success['token'] =  $user->createToken('AccessToken')->accessToken;
                $success['expires in'] = '60 Minutes';
                $success['user']= $user;
                return response()->json(['success' => $success,"status"=>1,"status_code"=>200], 200);
            }
            return response()->json(['message'=>"User not active","status"=>0,"status_code"=>400],200);
        }else{
            return response()->json(['message'=>"Invalid email and password combination","status"=>0,"status_code"=>400],200);
        }
    }
}
