<?php

namespace App\Http\Controllers\API;

use App\Traits\BranchTrait;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class BranchController extends Controller
{
    use BranchTrait;
    public function __construct()
    {
        $this->middleware('auth:api');
    }
    public  function  index(Request $request)
    {
        $user = $request->user();
      $branches  = $this->allBranches($user->Company_id);
      return response()->json([
          "status"=>1,
          "status_code"=>200,
          "message"=>"Success",
          "branches"=>$branches
      ]);
    }

    public function getBranchCategories(Request $request,$branch_code)
    {
        $user = $request->user();
        $branches  = $this->getBranchCatalogues($branch_code,$user->Company_id);
        if($branches->count() > 0)
        {
            return response()->json([
                "status_code"=>200,
                "status"=>1,
                "message"=>"Success",
                "branches"=>$branches
            ]);
        }

        return response()->json([
            "status_code"=>400,
            "status"=>0,
            "message"=>"No branches found",
            "branches"=>$branches
        ]);

    }


}
