<?php

namespace App\Http\Controllers\API;

use App\Models\EnrollmentMaster;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;

class CompanyAuthController extends Controller
{
    public function companyLogin(Request $request,$program_slug)
    {
        $validator  = Validator::make($request->all(),[
            "membership_id"=>'required',
            "company_username"=>'required',
            "company_password"=>"required"
        ]);
        if($validator->fails())
        {
            return response()->json([
                'status'=>0,
                "message"=>"Invalid user request",
                "errors"=>$validator->errors()
            ]);
        }

       $username = $request->company_username;
       $password = $request->company_password;

        $user  = EnrollmentMaster::join("lsl_company_master AS comp",function($query)use($username,$password){
                            return  $query->on("comp.Company_id","lsl_enrollment_master.Company_id")
                                  ->where("Company_username",$username)->where("Company_password",$password);
                    })->join("lsl_loyalty_program_master AS pro",function($query)use($program_slug){
                       return $query->on("comp.Company_id","pro.Company_id")->where("slug",$program_slug);
                    })->where("Membership_id",$request->membership_id)
                    ->select(['First_name','lsl_enrollment_master.Current_balance',
                        'LoggedIn_flag','Membership_id','User_email_id','Last_login_datetime','Enrollment_id','lsl_enrollment_master.Company_id'])->first();
        if($user==null)
        {
            return response()->json([
                'status'=>0,
                "message"=>"Invalid company password, username or membership ID combination",
            ]);
        }
        $tokenObject = $user->createToken('AccessToken')->accessToken;
        return response()->json([
            'status'=>1,
            "token"=>$tokenObject->token,
            "expires_in"=>$tokenObject->token->expires_at->diffInSeconds(Carbon::now()),
            "user"=>$user
        ]);

    }
}
