<?php

namespace App\Http\Controllers\API;

use App\Traits\StatementTrait;
use http\Cookie;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Validator;

class StatementController extends Controller
{
    use StatementTrait;

    public function __construct()
    {
        $this->middleware('auth:api');
    }

    public function index(Request $request)
    {
        $validator = Validator::make($request->all(),[
            'from_date'=>'nullable|date',
            'to_date'=>'nullable|date'
        ]);
        $user = $request->user();
        $min_date = date("Y-m-d",strtotime($request->from_date));

        $max_date =  date("Y-m-d",strtotime($request->to_date));
        $user_statement = $this->getUserStatementSummary($user->Membership_id,$user->Company_id);
        $limit = $request->input("limit")<1?10:$request->input("limit");

        if($min_date)
        {
            $user_statement = $user_statement->where("Transaction_date",">=",$min_date);
        }
        if($max_date)
        {
            $user_statement = $user_statement->where("Transaction_date","<=",$max_date);
        }
        $user_statement = $user_statement->paginate($limit);
        return response()->json([
            "status"=>1,
            "status_code"=>200,
            "user_statements"=>$user_statement
        ]);
    }


}
