<?php

namespace App\Jobs;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;

class CustomRawMailJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;
    /**
     * @var array
     */
    public $configuration;
    /**
     * @var Mailable
     */
    public $message;
    /**
     * @var string
     */
    public $to_email;
    private $from_email;
    private $subject;
    private $name;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct(array $configuration, string $to_email,$name, string $message,$from_email,$subject)
    {
        $this->configuration = $configuration;
        $this->to_email = $to_email;
        $this->message = $message;
        $this->from_email = $from_email;
        $this->subject = $subject;
        $this->name = $name;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $mailer = app()->makeWith('company.mailer', $this->configuration);

        $from_email = $this->from_email;
        $to_email = $this->to_email;
        $subject = $this->subject;
        $name = $this->name;

        $mailer->raw($this->message,function($message)use($from_email,$to_email,$subject,$name){
            $message->to($to_email,$name);
            $message->subject($subject);
        });

    }
}
