<?php

namespace App\Mail\Auction;

use App\Traits\UserNotificationTrait;
use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;
use App\Traits\MailNotification;

class ReBidMail extends Mailable
{
    use Queueable, SerializesModels,MailNotification,UserNotificationTrait;

    private $auction;
    private $user;
    private $company;
    private $current_bid;
    public function __construct($user,$auction,$company,$current_bid)
    {
       $this->auction = $auction;
       $this->user = $user;
       $this->company = $company;
       $this->current_bid = $current_bid;
    }


    public function build()
    {
        $email_structure = $this->getEmailStructure($this->company->Company_id,50);
        $email_variables = $this->getEmailVariable("Customer Auction Bid");
        $values = $this->assignValues($this->user,$this->company,$this->auction,$this->current_bid);

        $email_structure->Email_subject = str_replace('$Auction_name',$this->auction->Auction_name,
                                            $email_structure->Email_subject);
        $email_structure->Footer_notes =
            str_replace('$Website', $this->company->Website,$email_structure->Footer_notes);
        foreach($email_variables as $variable)
        {
            if(isset($values["".$variable.""]))
            $email_structure->Email_body = str_replace($variable,$values["".$variable.""],$email_structure->Email_body);
        }
        $this->createNotification($this->user,$email_structure->Email_body,14,0);
        return $this->from($this->company->Company_person_Email,$this->company->Company_name)
        ->subject($email_structure->Email_subject)->view('mail.general')
        ->with(['structure'=>$email_structure]);
    }

    private function assignValues($user,$company,$auction,$current_bid)
    {
        return ['$First_name'=>$user->First_name,'$Last_name'=>$user->Last_name,'$Auction_name'=>$auction->Auction_name,
        '$Company_name'=>$company->Company_name,'$Membership_id'=>$user->Membership_id,'$Auction_start_date'=>$auction->From_date,
        '$Auction_end_date'=>$auction->To_date,'$Membership_email'=>$user->User_email_id,'$Loyalty_program_id'=>$user->Loyalty_programme_id,
        '$Website'=>$company->Website,'$Application_website'=>$company->Website,'$Facebook_icon'=>'','$Current_bid_value'=>$current_bid,
        '$Twitter_icon'=>'','$Google_plus_icon'=>'','$Linkedin_icon'=>'',' $iOS_icon'=>'','$Item_name'=>$auction->Prize,
        '$Android_icon'=>'','$Current_balance'=>$user->Current_balance,'$Bid_value'=>$current_bid];
    }
}
