<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

use App\Traits\MailNotification;


class EnrollmentMail extends Mailable
{
    use Queueable, SerializesModels,MailNotification;

    /**
     * Create a new message instance.
     *
     * @return void
     */

    public  $user="";
    public $company="";

    public function __construct($company,$recipient)
    {
        $this->company = $company;
        $this->user = $recipient;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {

        $email_structure = $this->getEmailStructure($this->company->Company_id,1);
        $email_variables = $this->getEmailVariable("Enrollment");

        $values = $this->assignValues($this->user,$this->company);
        $email_structure->Email_subject = str_replace('$Loyalty_program_name',$this->company->Loyalty_program_name,$email_structure->Email_subject);
        $email_structure->Footer_notes =
            str_replace('$Website', $this->company->Website,$email_structure->Footer_notes);
        foreach($email_variables as $variable)
        {
            if(isset($values["".$variable.""]))
            $email_structure->Email_body = str_replace($variable,$values["".$variable.""],$email_structure->Email_body);
        }

        return $this->from($this->company->Company_person_Email,$this->company->Company_name)
        ->subject($email_structure->Email_subject)->view('mail.general')->with(['structure'=>$email_structure]);
    }





    private function assignValues($user,$company)
    {
        return ['$First_name'=>$user->First_name,'$Last_name'=>$user->Last_name,'$Loyalty_program_name'=>$company->Loyalty_program_name,
        '$Company_name'=>$company->Company_name,'$Membership_id'=>$user->Membership_id,'$Password'=>$user->Password,
         '$Pin'=>$user->pin,'$Website'=>$company->Website,
         '$Tier_name'=>$company->Tier_name,'$User_name'=>$user->User_email_id,'$Facebook_icon'=>'',
         '$Twitter_icon'=>'','$Google_plus_icon'=>'','$Linkedin_icon'=>'',' $iOS_icon'=>'',
         '$Android_icon'=>'','$Joining_bonus'=>0
        ];
    }













}
