<?php

namespace App\Mail\Passwords;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class ResetPasswordMail extends Mailable
{
    use Queueable, SerializesModels;
    private $user;
    private $mail_configuration;
    public $company;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($user,$company)
    {
        //
        $this->user = $user;
        $this->company = $company;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->subject('Password Reset Successful')
            ->markdown('vendor.notifications.email')->with([
                "level" => "default",
                "greeting" => "Hi, ".$this->user->First_name."!",
                "introLines" => [
                    "You have changed your password successfully."
                ],
                "company" => $this->company,
                "outroLines" => [
                    "If you did change password, no further action is required."
                ]
            ])->with([ "company" => $this->company]);
    }
}
