<?php

namespace App\Traits;


use App\Jobs\CustomMailJob;
use App\Mail\Promo\PromoMail;
use App\Mail\Transfer\CreditMail;
use App\Mail\Transfer\DebitMail;
use App\Models\EnrollmentMaster;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;

trait TransferTrait
{
    use KnockoutTrait;
    protected  function getRecipient($membership_id,$programme_id)
    {
        return
            DB::table('lsl_enrollment_master as enrol')
            ->join('lsl_company_master as comp','enrol.Company_id','=','comp.Company_id')
            ->select('comp.Pin_no_applicable','enrol.Active_flag','enrol.User_email_id','enrol.Membership_id'
                ,'enrol.First_name','enrol.Last_name','enrol.Current_balance','enrol.Enrollment_id')->where('enrol.Loyalty_programme_id',$programme_id)
            ->where('enrol.Membership_id',$membership_id)->first();
    }
    protected function creditAccount($sender,$enrollment_id,$amount,$company)
    {
       $recipient = EnrollmentMaster::where('Enrollment_id',$enrollment_id)->first();
       $recipient->Current_balance += $amount;
       $recipient->save();
        $transaction_id = $this->saveTransactionObject($recipient,$sender,3,$amount);

        CustomMailJob::dispatch($company->mail_configuration->toArray(),$recipient->User_email_id,
            new CreditMail($sender,$recipient,$amount,$company));
    }

    protected function  debitAccount($enrollment_id,$recipient,$amount,$company)
    {
       $sender = EnrollmentMaster::where('Enrollment_id',$enrollment_id)->first();
       $sender->Current_balance -= $amount;
       $sender->save();
       $transaction_id = $this->saveTransactionObject($sender,$recipient,6,$amount);
       $user_points = $this->getUserPoints($sender->Company_id,$sender->Enrollment_id);
       $this->deductUserPoints($user_points,$amount,$sender->Enrollment_id,$transaction_id,$company->Company_id,0,"");

        CustomMailJob::dispatch($company->mail_configuration->toArray(),$sender->User_email_id,
            new DebitMail($sender,$recipient,$amount,$company));
    }

    protected function saveTransactionObject($user,$user2,$transaction_type,$amount)
    {
        return \DB::table("lsl_transaction")->insertGetId([
            'Transaction_type_id'=>$transaction_type,'Company_id'=>$user->Company_id,'Child_company_id'=>0,'Member1_enroll_id'=>$user->Enrollment_id,
            'Membership1_id'=>$user->Membership_id,'Branch_user_id'=>0,'Transaction_date'=>date("Y-m-d H:m:s",time()),
            'Branch_user_pin'=>null, 'Item_code'=>"",'Merchandize_partner_id'=>0,'Merchandize_partner_branch'=>"",
            'Quantity'=>0,"Company_transaction_Type"=>"","Transaction_channel_code"=>"","Product_group_code"=>"","Product_brand_code"=>"",'Redeem_amount'=>0,
            'Redeem_points'=>0,"Transaction_amount"=>0.00,"Product_cost"=>0.00,"Redeem_amount_value"=>0.00,
            "Total_shipping_points"=>0.00,"Total_shipping_cost"=>0.00,"Bonus_points"=>$transaction_type==3?$amount:0.00,"Loyalty_points"=>0.00,
            "Knockout_points"=>0.00,"Balance_to_pay"=>0.00,'Payment_type_id'=>0,'Partner_billing_price'=>0,"Transfer_points"=>$transaction_type==6?$amount:0.00,
            "Account_no"=>0,'Partner_cost_payable'=>0,'Loyalty_program_id'=>0,"Member2_enroll_id"=>$user2->Enrollment_id,"Membership2_id"=>$user2->Membership_id,
            'Shipping_points'=>0,'Source'=>"",'Total_shipping_value'=>0,'Branch_code'=>"",'Remarks'=>"",
            'Delivery_flag'=>0,'Delivery_method'=>0,'Voucher_status'=>0,'Order_status'=>0,'Voucher_no'=>"",'Order_no'=>0,
            'Report_status'=>0,'Field_5_name'=>'','Delivery_state_id'=>0
        ],"Transaction_id");
    }


}
