<?php

use Illuminate\Http\Request;


Route::get('/',function(){
    return response()->json("success");
});


Route::group(['namespace'=>'API'],function(){

    Route::post("/{program_slug}/company_login","CompanyAuthController@companyLogin");

    Route::post("/{company}/login",'AuthController@createToken');
    Route::post("/{company}/register",'RegisterController@registerUser');
    Route::get("/profile",'UserController@user_profile');
    Route::post('/profile',"UserController@update_profile");

    Route::get("/catalogue_items/most_redeemed",'ProductController@mostRedeemItems');

    //Routes for the locations
    Route::get("country/{countryId}",'LocationController@states');
    Route::get("states/{stateId}",'LocationController@cities');

    //Routes for the categories
    Route::get("/categories",'CategoryController@company_categories');
    Route::get("/multi_categories",'CategoryController@nested_categories');
    Route::get("/branch_items/{branch_code}/{id}",'CategoryController@nested_categories_products');
    Route::get("/branches",'BranchController@index');
    Route::get("/branch_items/{branch_code}",'BranchController@getBranchCategories');

    //Routes for the catalogues
    Route::post("/catalogues/{categoryId}",'ProductController@category_products');
    Route::get("/items/{productId}",'ProductController@show_product');


    //Route for the cart
    Route::post("/cart/add",'CartController@add_to_cart');
    Route::post("/cart/update",'CartController@update_cart');
    Route::get("/cart/items",'CartController@cart_items');
    Route::post("/cart/delete",'CartController@delete_item');

    //Route for WishLists Items
    Route::get("wish_lists/items",'WishlistController@userWishLists');
    Route::post("wish_lists/add",'WishlistController@addWishListItem');
    Route::post("wish_lists/delete",'WishlistController@deleteWishListItemItem');

    //Route for the delivery service
    Route::post("/delivery/price",'DeliveryController@getDeliveryPrice');
    Route::post("/cart/checkout",'DeliveryController@checkoutCart');

    //Route for the Checkout services
    Route::post("/checkout/items",'CheckoutController@getCheckOutItems');

    //Route for the Checkout services
    Route::post("/client/checkouts",'ClientCheckoutController@checkout');
    Route::post("/client/delivery_price",'ClientCheckoutController@getDeliveryPrice');
    Route::post("/client/cart_summary",'ClientCheckoutController@getCartTotal');

    //Route for Shipping Address
    Route::post("/shipping/store",'ShippingController@store');
    Route::post("/shipping/{id}/update",'ShippingController@update');

    //Route for User Surveys
    Route::get("/surveys",'SurveyController@getSurveys');
    Route::get("/surveys/{surveyId}",'SurveyController@showSurvey');
    Route::post("/surveys/{surveyId}/submit",'SurveyController@submitSurvey');

    //Route for User Auctions
    Route::get("/auctions",'AuctionController@index');
    Route::get("/auctions/{auctionId}",'AuctionController@detail');
    Route::post("/auctions/{auctionId}/bid",'AuctionController@submitBid');

    //Route for promocodes
    Route::post("/promo/getpoints",'PromoCodeController@getPoints');

    //Route for user transaction statement
    Route::post("/statement",'StatementController@index');

    //Route for user transfer of points
    Route::post("/points/transfer",'TransferController@transferPoints');

    //Route for User Notifications
    Route::get("/full_notifications",'UserNotificationController@fullNotifications');
    Route::get("/notifications",'UserNotificationController@index');
    Route::get("/notifications/{notification_id}",'UserNotificationController@getNotificationContent');

    Route::post("/notifications/{notification_id}",'UserNotificationController@deleteNotification');

    //Route for User Password
    Route::post("/{slug}/request_reset",'PasswordController@requestPasswordReset');
    Route::post("/{slug}/verify_token",'PasswordController@verifyToken');
    Route::post("/{slug}/reset_password","PasswordController@reset");

    //Route for User Password
    Route::post('/{slug}/contact',"ContactController@index");


    Route::post("/change_password","PasswordController@changePassword")->middleware("auth:api");

    //Route for User Pin Reset
    Route::post('/pin/pin_reset',"PinController@pinResetRequest");
    Route::post('/pin/pin_update',"PinController@resetPin");
    Route::post('/pin/verifytoken',"PinController@verifyToken");
    Route::post('/change_pin',"PinController@changePin");
});

